setwd("/Users/...")

pdata <- read.csv("300_Portfolios_fortest.csv", header=T)
pdata <- pdata[1:210,]
pdata <- pdata[!colSums(pdata)%in% NA]

t <- (ncol(pdata)-1)

fffactor <- read.csv("F-F__Factors_s.CSV", header=T)


table3.FF <- matrix(NA,ncol = 9,nrow = 1)

colnames(table3.FF ) <-c("con","rm", "SMB", "HML", "t.con","t.rm","t.SMB","t.HML","r2")

v.betas <- - matrix(, nrow = t, ncol = 3)

for (i in 1:t){
  
  y<- pdata[,(i+1)]
  fit1 <- lm( y ~ fffactor[,2]+fffactor[,3]+fffactor[,4])
  
  v.betas[i,1] <-coefficients(fit1)[2]
  v.betas[i,2] <-coefficients(fit1)[3]
  v.betas[i,3] <-coefficients(fit1)[4]
  
}



pdata1 <- pdata[2:ncol(pdata)]
meanr <- as.vector(colMeans(pdata1))


finalfit <- lm(meanr ~ v.betas[,1:3])
output.FF <- summary(finalfit)

table3.FF[1,1:4] <- output.FF$coefficients[,1]
table3.FF[1,5:8] <- output.FF$coefficients[,3]
table3.FF[1,9] <- output.FF$adj.r.squared

write.csv(table3.FF,file="table3.FF.csv")



